#!/bin/sh

function makenew {
   # If we have already saved an "old" version of this file, delete the current one.
   if [ -e ${1}.old ] ; then
      rm ${1}
   else
      # Save the current version of the file for future reference.
      mv ${1} ${1}.old
   fi
   mv ${1}.new ${1}
}

#-----------------------------------------------------------------------

if [ ! -d share ] ; then
   echo "Error: Starting in the wrong directory.  Try mipsisa32-elf..."
   exit
fi

#-----------------------------------------------------------------------

echo "Editing mipsisa32-elf/include/cstdio..."

infile=mipsisa32-elf/include/cstdio
if [ -e ${infile}.old ] ; then
   infile=${infile}.old
fi

if [ ! -e ${infile} ] ; then
   echo "Error: Couldn't find ${infile}!"
fi

sed \
   -e "/^ .*::remove/ s,.*,//& // msieweke," \
   -e "/^ .*::rename/ s,.*,//& // msieweke," \
   -e "/^ .*::tmpfile/s,.*,//& // msieweke," \
   -e "/^ .*::tmpnam/ s,.*,//& // msieweke," \
   ${infile} \
   >mipsisa32-elf/include/cstdio.new

makenew mipsisa32-elf/include/cstdio

#-----------------------------------------------------------------------

echo "Editing mipsisa32-elf/include/mipsisa32-elf/bits/ctype_base.h..."

infile=mipsisa32-elf/include/mipsisa32-elf/bits/ctype_base.h
if [ -e ${infile}.old ] ; then
   infile=${infile}.old
fi

if [ ! -e ${infile} ] ; then
   echo "Error: Couldn't find ${infile}!"
fi

sed -e "/struct ctype_base/i\\
// msieweke - BEGIN - added from ctype.h\\
\\
#ifndef _U\\
    #define _U 01\\
    #define _L 02\\
    #define _N 04\\
    #define _S 010\\
    #define _P 020\\
    #define _C 040\\
    #define _X 0100\\
    #define _B 0200\\
#endif\\
\\
// msieweke - END - added from ctype.h\\
" \
   ${infile} \
   >mipsisa32-elf/include/mipsisa32-elf/bits/ctype_base.h.new

makenew mipsisa32-elf/include/mipsisa32-elf/bits/ctype_base.h

#-----------------------------------------------------------------------

echo "Editing mipsisa32-elf/include/mipsisa32-elf/bits/c++config.h..."

infile=mipsisa32-elf/include/mipsisa32-elf/bits/c++config.h
if [ -e ${infile}.old ] ; then
   infile=${infile}.old
fi

if [ ! -e ${infile} ] ; then
   echo "Error: Couldn't find ${infile}!"
fi

sed \
   -e "/^#define _GLIBCPP_HAVE_MODFF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_EXPF 1/   s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_ACOSF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_ASINF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_ATAN2F 1/ s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_ATANF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_CEILF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_COSHF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_EXPF 1/   s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_FLOORF 1/ s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_FMODF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_FREXPF 1/ s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_LDEXPF 1/ s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_LOG10F 1/ s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_LOGF 1/   s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_MODFF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_POWF 1/   s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_SINHF 1/  s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_TANF 1/   s,.*,// & // msieweke," \
   -e "/^#define _GLIBCPP_HAVE_TANHF 1/  s,.*,// & // msieweke," \
   ${infile} \
   >mipsisa32-elf/include/mipsisa32-elf/bits/c++config.h.new

makenew mipsisa32-elf/include/mipsisa32-elf/bits/c++config.h

#-----------------------------------------------------------------------

echo "Checking mipsisa32-elf/include/bits/stl_alloc.h..."

infile=mipsisa32-elf/include/bits/stl_alloc.h

if [ ! -e ${infile} ] ; then
   echo "Error: Couldn't find ${infile}!"
fi

grep V2StlAllocMutexLock ${infile}

if [ $? != 0 ] ; then
   echo "Error: stl_alloc.h needs to be changed to use BCM alloc mutex!"
   exit
fi

#-----------------------------------------------------------------------

echo "Adding ctype_.o and missing.o to C++ library..."

cd mipsisa32-elf/lib

if [ ! -e libstdc++.a.orig ] ; then
   cp libstdc++.a libstdc++.a.orig
fi

if [ "$OS" == "Windows_NT" ] ; then
   if [ "$MSYSTEM" == "MINGW32" ] ; then
      cp /c/v2/ecos/ctype_.o   /c/v2/ecos/missing.o   .
   else
      cp /cygdrive/c/v2/ecos/ctype_.o   /cygdrive/c/v2/ecos/missing.o   .
   fi
else
   cp /home/msieweke/ecos20/ctype_.o /home/msieweke/ecos20/missing.o .
fi

ar rv libstdc++.a ctype_.o missing.o

exit


